CAST5Engine (Bouncy Castle Library 1.85 API Specification)
Date: 2026-07-12

org.bouncycastle.crypto.engines

## Class CAST5Engine

- java.lang.Object
- - org.bouncycastle.crypto.engines.CAST5Engine

- All Implemented Interfaces:
    BlockCipher
  Direct Known Subclasses:
    CAST6Engine

      public class CAST5Engine
      extends java.lang.Object
      implements BlockCipher

  A class that provides CAST key encryption operations, such as encoding data and generating keys. All the algorithms herein are from the Internet RFC's RFC2144 - CAST5 (64bit block, 40-128bit key) RFC2612 - CAST6 (128bit block, 128-256bit key) and implement a simplified cryptography interface.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected int[]` | `_Km`
    `protected int[]` | `_Kr`
    `protected static int` | `BLOCK_SIZE`
    `protected static int` | `MAX_ROUNDS`
    `protected static int` | `RED_ROUNDS`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `CAST5Engine()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected void` | `Bits32ToBytes(int in, byte[] b, int offset)`
    `protected void` | `Bits32ToInts(int in, int[] b, int offset)`
    `protected int` | `BytesTo32bits(byte[] b, int i)`
    `protected void` | `CAST_Decipher(int L16, int R16, int[] result)`
    `protected void` | `CAST_Encipher(int L0, int R0, int[] result)` Does the 16 rounds to encrypt the block.
    `protected int` | `decryptBlock(byte[] src, int srcIndex, byte[] dst, int dstIndex)` Decrypt the given input starting at the given offset and place the result in the provided buffer starting at the given offset.
    `protected int` | `encryptBlock(byte[] src, int srcIndex, byte[] dst, int dstIndex)` Encrypt the given input starting at the given offset and place the result in the provided buffer starting at the given offset.
    `protected int` | `F1(int D, int Kmi, int Kri)` The first of the three processing functions for the encryption and decryption.
    `protected int` | `F2(int D, int Kmi, int Kri)` The second of the three processing functions for the encryption and decryption.
    `protected int` | `F3(int D, int Kmi, int Kri)` The third of the three processing functions for the encryption and decryption.
    `java.lang.String` | `getAlgorithmName()` Return the name of the algorithm the cipher implements.
    `int` | `getBlockSize()` Return the block size for this cipher (in bytes).
    `void` | `init(boolean encrypting, CipherParameters params)` initialise a CAST cipher.
    `protected int` | `IntsTo32bits(int[] b, int i)`
    `int` | `processBlock(byte[] in, int inOff, byte[] out, int outOff)` Process one block of input from the array in and write it to the out array.
    `void` | `reset()` Reset the cipher.
    `protected void` | `setKey(byte[] key)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### MAX_ROUNDS

          protected static final int MAX_ROUNDS

      See Also:
        Constant Field Values

    - #### RED_ROUNDS

          protected static final int RED_ROUNDS

      See Also:
        Constant Field Values

    - #### BLOCK_SIZE

          protected static final int BLOCK_SIZE

      See Also:
        Constant Field Values

    - #### _Kr

          protected int[] _Kr

    - #### _Km

          protected int[] _Km

  - ### Constructor Detail

    - #### CAST5Engine

          public CAST5Engine()

  - ### Method Detail

    - #### init

          public void init(boolean encrypting,
                           CipherParameters params)

      initialise a CAST cipher.
      Specified by:
        `init` in interface `BlockCipher`
      Parameters:
        `encrypting` - whether or not we are for encryption.
        `params` - the parameters required to set up the cipher.
      Throws:
        `java.lang.IllegalArgumentException` - if the params argument is inappropriate.

    - #### getAlgorithmName

          public java.lang.String getAlgorithmName()

      Description copied from interface: `BlockCipher`
      Return the name of the algorithm the cipher implements.
      Specified by:
        `getAlgorithmName` in interface `BlockCipher`
      Returns:
        the name of the algorithm the cipher implements.

    - #### processBlock

          public int processBlock(byte[] in,
                                  int inOff,
                                  byte[] out,
                                  int outOff)

      Description copied from interface: `BlockCipher`
      Process one block of input from the array in and write it to the out array.
      Specified by:
        `processBlock` in interface `BlockCipher`
      Parameters:
        `in` - the array containing the input data.
        `inOff` - offset into the in array the data starts at.
        `out` - the array the output data will be copied into.
        `outOff` - the offset into the out array the output will start at.
      Returns:
        the number of bytes processed and produced.

    - #### reset

          public void reset()

      Description copied from interface: `BlockCipher`
      Reset the cipher. After resetting the cipher is in the same state as it was after the last init (if there was one).
      Specified by:
        `reset` in interface `BlockCipher`

    - #### getBlockSize

          public int getBlockSize()

      Description copied from interface: `BlockCipher`
      Return the block size for this cipher (in bytes).
      Specified by:
        `getBlockSize` in interface `BlockCipher`
      Returns:
        the block size for this cipher in bytes.

    - #### setKey

          protected void setKey(byte[] key)

    - #### encryptBlock

          protected int encryptBlock(byte[] src,
                                     int srcIndex,
                                     byte[] dst,
                                     int dstIndex)

      Encrypt the given input starting at the given offset and place the result in the provided buffer starting at the given offset.
      Parameters:
        `src` - The plaintext buffer
        `srcIndex` - An offset into src
        `dst` - The ciphertext buffer
        `dstIndex` - An offset into dst

    - #### decryptBlock

          protected int decryptBlock(byte[] src,
                                     int srcIndex,
                                     byte[] dst,
                                     int dstIndex)

      Decrypt the given input starting at the given offset and place the result in the provided buffer starting at the given offset.
      Parameters:
        `src` - The plaintext buffer
        `srcIndex` - An offset into src
        `dst` - The ciphertext buffer
        `dstIndex` - An offset into dst

    - #### F1

          protected final int F1(int D,
                                 int Kmi,
                                 int Kri)

      The first of the three processing functions for the encryption and decryption.
      Parameters:
        `D` - the input to be processed
        `Kmi` - the mask to be used from Km[n]
        `Kri` - the rotation value to be used

    - #### F2

          protected final int F2(int D,
                                 int Kmi,
                                 int Kri)

      The second of the three processing functions for the encryption and decryption.
      Parameters:
        `D` - the input to be processed
        `Kmi` - the mask to be used from Km[n]
        `Kri` - the rotation value to be used

    - #### F3

          protected final int F3(int D,
                                 int Kmi,
                                 int Kri)

      The third of the three processing functions for the encryption and decryption.
      Parameters:
        `D` - the input to be processed
        `Kmi` - the mask to be used from Km[n]
        `Kri` - the rotation value to be used

    - #### CAST_Encipher

          protected final void CAST_Encipher(int L0,
                                             int R0,
                                             int[] result)

      Does the 16 rounds to encrypt the block.
      Parameters:
        `L0` - the LH-32bits of the plaintext block
        `R0` - the RH-32bits of the plaintext block

    - #### CAST_Decipher

          protected final void CAST_Decipher(int L16,
                                             int R16,
                                             int[] result)

    - #### Bits32ToInts

          protected final void Bits32ToInts(int in,
                                            int[] b,
                                            int offset)

    - #### IntsTo32bits

          protected final int IntsTo32bits(int[] b,
                                           int i)

    - #### Bits32ToBytes

          protected final void Bits32ToBytes(int in,
                                             byte[] b,
                                             int offset)

    - #### BytesTo32bits

          protected final int BytesTo32bits(byte[] b,
                                            int i)